<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_InsuranceInfo StructType
 * @subpackage Structs
 */
class JP_InsuranceInfo extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Descriptions
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_Description
     */
    public $Descriptions;
    /**
     * The Images
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_ImageLong
     */
    public $Images;
    /**
     * The Coverages
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_Coverage
     */
    public $Coverages;
    /**
     * The EmergencyContact
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_EmergencyContact
     */
    public $EmergencyContact;
    /**
     * Constructor method for JP_InsuranceInfo
     * @uses JP_InsuranceInfo::setName()
     * @uses JP_InsuranceInfo::setDescriptions()
     * @uses JP_InsuranceInfo::setImages()
     * @uses JP_InsuranceInfo::setCoverages()
     * @uses JP_InsuranceInfo::setEmergencyContact()
     * @param string $name
     * @param \ArrayType\ArrayOfJP_Description $descriptions
     * @param \ArrayType\ArrayOfJP_ImageLong $images
     * @param \ArrayType\ArrayOfJP_Coverage $coverages
     * @param \StructType\JP_EmergencyContact $emergencyContact
     */
    public function __construct($name = null, \ArrayType\ArrayOfJP_Description $descriptions = null, \ArrayType\ArrayOfJP_ImageLong $images = null, \ArrayType\ArrayOfJP_Coverage $coverages = null, \StructType\JP_EmergencyContact $emergencyContact = null)
    {
        $this
            ->setName($name)
            ->setDescriptions($descriptions)
            ->setImages($images)
            ->setCoverages($coverages)
            ->setEmergencyContact($emergencyContact);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_InsuranceInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Descriptions value
     * @return \ArrayType\ArrayOfJP_Description|null
     */
    public function getDescriptions()
    {
        return $this->Descriptions;
    }
    /**
     * Set Descriptions value
     * @param \ArrayType\ArrayOfJP_Description $descriptions
     * @return \StructType\JP_InsuranceInfo
     */
    public function setDescriptions(\ArrayType\ArrayOfJP_Description $descriptions = null)
    {
        $this->Descriptions = $descriptions;
        return $this;
    }
    /**
     * Get Images value
     * @return \ArrayType\ArrayOfJP_ImageLong|null
     */
    public function getImages()
    {
        return $this->Images;
    }
    /**
     * Set Images value
     * @param \ArrayType\ArrayOfJP_ImageLong $images
     * @return \StructType\JP_InsuranceInfo
     */
    public function setImages(\ArrayType\ArrayOfJP_ImageLong $images = null)
    {
        $this->Images = $images;
        return $this;
    }
    /**
     * Get Coverages value
     * @return \ArrayType\ArrayOfJP_Coverage|null
     */
    public function getCoverages()
    {
        return $this->Coverages;
    }
    /**
     * Set Coverages value
     * @param \ArrayType\ArrayOfJP_Coverage $coverages
     * @return \StructType\JP_InsuranceInfo
     */
    public function setCoverages(\ArrayType\ArrayOfJP_Coverage $coverages = null)
    {
        $this->Coverages = $coverages;
        return $this;
    }
    /**
     * Get EmergencyContact value
     * @return \StructType\JP_EmergencyContact|null
     */
    public function getEmergencyContact()
    {
        return $this->EmergencyContact;
    }
    /**
     * Set EmergencyContact value
     * @param \StructType\JP_EmergencyContact $emergencyContact
     * @return \StructType\JP_InsuranceInfo
     */
    public function setEmergencyContact(\StructType\JP_EmergencyContact $emergencyContact = null)
    {
        $this->EmergencyContact = $emergencyContact;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_InsuranceInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
